%{
/* yacc specification */
#include <stdio.h>
#include "test.h"

extern struct expr *make();
%}
/*
%union {
  int integer;
  struct expr *node;
};
*/
%token<integer> DIGIT

%type<node> expr,number

%left '+' '*' 

%start list

%%
list :
	 | list stat '\n'
	 ;
stat : expr
       { tree_expr($1); printf("\n"); }
     ;
expr : expr '*' expr
       { $$ = make(2); $$->op = '*';
         $$->left = $1; $$->right = $3; }
     | expr '+' expr
       { $$ = make(2); $$->op = '+';
         $$->left = $1; $$->right = $3; }
     | number
       { $$ = $1; }
     ;
number : DIGIT
       { $$ = make(1); $$->val = $1;
         $$->left = (struct expr*)0;
         $$->right = (struct expr*)0; }
       ;

%%

yyerror(s)
char *s;
{ fprintf(stderr,"%s\n",s); }

yywrap() { return(1); }


